import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import { forwardRef, createElement, cloneElement, Children, useEffect } from 'react';
import PropTypes from 'prop-types';
var AtomTooltipExtendedChildren = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var children = _ref.children,
      className = _ref.className,
      onTouchEnd = _ref.onTouchEnd,
      disableTitle = _ref.disableTitle,
      restoreTitle = _ref.restoreTitle,
      handleDragElement = _ref.handleDragElement,
      handleClickOutsideElement = _ref.handleClickOutsideElement,
      setter = _ref.setter,
      otherProps = _objectWithoutPropertiesLoose(_ref, ["children", "className", "onTouchEnd", "disableTitle", "restoreTitle", "handleDragElement", "handleClickOutsideElement", "setter"]);

  useEffect(function () {
    var eventsStack = [[ref.current, 'mouseover', disableTitle], [ref.current, 'mouseout', restoreTitle], [ref.current, 'touchstart', restoreTitle], [ref.current, 'mouseover', handleDragElement], [window, 'click', handleClickOutsideElement], [window, 'touchend', handleClickOutsideElement]];
    eventsStack.map(function (_ref2) {
      var target = _ref2[0],
          eventname = _ref2[1],
          callback = _ref2[2];
      target.addEventListener(eventname, callback);
    });
    return function () {
      eventsStack.map(function (_ref3) {
        var target = _ref3[0],
            eventname = _ref3[1],
            callback = _ref3[2];
        target.removeEventListener(eventname, callback);
      });
    };
  }, [disableTitle, restoreTitle, handleDragElement, handleClickOutsideElement, ref]);
  return Children.map(Children.only(children), function (child) {
    var _child$props = child.props,
        onClick = _child$props.onClick,
        title = _child$props.title;
    setter({
      onClick: onClick,
      title: title
    });
    return typeof child.type !== 'string' ? /*#__PURE__*/createElement('div', {
      ref: ref,
      className: className + " " + className + "--wrapper",
      onTouchEnd: onTouchEnd
    }, /*#__PURE__*/cloneElement(child)) : /*#__PURE__*/cloneElement(child, {
      ref: ref,
      className: className,
      onTouchEnd: onTouchEnd
    });
  });
});
export default AtomTooltipExtendedChildren;